package mactrans.database;

import java.util.ArrayList;
import java.util.Iterator;
import org.w3c.dom.*;

/**
 * 
 * @author Iuliana Zibilianu (iuliacaz@yahoo.com)
 * @version $Revision: 1.16 $
 * 
 * <pre>
 * $Log: Dictionary.java,v $
 * Revision 1.16  2005/02/16 10:04:43  vschwarz
 * replaced System.out.println(...) with debug(...) in method getType(...)
 *
 * Revision 1.15  2005/02/16 09:55:21  izibilia
 * getType modified
 *
 * Revision 1.14  2005/02/16 06:52:25  izibilia
 * changed
 *
 * Revision 1.13  2005/02/15 17:26:36  jkieneck
 * improved
 *
 * Revision 1.12  2005/02/14 15:16:21  mactrans
 * changed to cope with it
 *
 * Revision 1.8  2005/02/08 20:48:09  dfriehe
 * improved
 *
 * Revision 1.7  2005/02/01 15:30:11  dfriehe
 * case sensivity??!
 *
 * Revision 1.6  2005/01/30 15:56:28  jkieneck
 * added constructor with modulename
 *
 * Revision 1.5  2005/01/27 15:22:31  dfriehe
 * ...
 *
 * Revision 1.4  2005/01/26 13:42:04  jkieneck
 * added debugging support
 *
 * Revision 1.3  2005/01/24 06:29:12  jkieneck
 * general update (too much to mention here...)
 *
 * Revision 1.2  2005/01/19 10:45:09  jkieneck
 * imported Iuliana's code into the skel
 *
 * Revision 1.1.1.1  2004/12/14 23:28:03  mactrans
 * added to repository
 *
 * </pre>
 */

public class Dictionary extends AbstractDatabase {
	public Dictionary( String filename ) {
		super( filename );
	}
	
	public Dictionary( String modname, String filename ) {
		super( modname, filename );
	}
	
	private void addCuv(Node tNode){
		//debug( tNode.getNodeName() );
		if (tNode.getNodeName().equals("MuS")) {
	   //if(tNode.getNodeType()==Node.ELEMENT_NODE) {
			
		   WordRecord s = new WordRecord();
			
		   NamedNodeMap nnm = tNode.getAttributes();//luam lista de atribute
			
		   Node idNode = nnm.getNamedItem("id");//id-ul
		   s.setId(idNode.getNodeValue());
			
		   Node lanNode = nnm.getNamedItem("language");//limba
		   s.setLanguage(lanNode.getNodeValue());
			
		   Node eqNode = nnm.getNamedItem("equiv");//echivalentul
		   s.setEquiv(eqNode.getNodeValue());

		   Node category=nnm.getNamedItem("gramcat");
		   String cat_val = category.getNodeValue();
		   if ( cat_val.equals("NOUN")) cat_val = "N";
		   if ( cat_val.equals("VERB")) cat_val = "V";
		   if ( cat_val.equals("ARTICLE")) cat_val = "DET";
		   if ( cat_val.equals("ADPOSITION")) cat_val = "P";
		   if ( cat_val.equals("ADJECTIVE")) cat_val = "ADJ";
		   if ( cat_val.equals("CONJUNCTION")) cat_val = "CONJ";
		   s.setG_cat(cat_val);
			
		   Node subcategory=nnm.getNamedItem("gramsubcat");
		   String sub_val = subcategory.getNodeValue();
		   s.setG_subcat(sub_val);
			
		   int reg=tNode.getChildNodes().getLength();
		   Node contNode = tNode.getChildNodes().item(1);//continutul;tempNode = myNL.item(i);
		   Node att =contNode.getAttributes().getNamedItem("InP");
		   if ( att != null ) {
		   Node copil=contNode.getChildNodes().item(1);
		   String num = new String("");
		   if ( copil.getChildNodes().item(0) != null ) {
		   	num=copil.getChildNodes().item(0).getNodeValue();
		   }
		   s.setElement(num,att.getNodeValue());
		   data.add(s); }
		}
		if ( tNode.getFirstChild() != null ) {
			addCuv( tNode.getFirstChild() );
		}
		if ( tNode.getNextSibling() != null ) {
			addCuv( tNode.getNextSibling() );
		}
	  }
	   
	public boolean fromXML( Document doc ) {
		addCuv( doc );
		return true;
	}
	
	public Document toXML()   {
		// TODO (only if MT should support xmlWriting)
		return null;
	}

	public WordRecord getByID( String idName ) {
		WordRecord result = null;
		Iterator it = data.iterator();
		
		while ( it.hasNext() && result == null ) {
			WordRecord tmp = (WordRecord) it.next();
			if ( tmp.getId().equals( idName) ) {
				result = tmp;
			}
		}
		if ( result == null ) {
			error( "id was not found ('" + idName + "')" );
		}
		return result;
	}
	
	public WordRecord getByEntry( String wordName ) {
		WordRecord result =null;
		Iterator it = data.iterator();
	
		while(it.hasNext() && result == null)
		{WordRecord tmp =(WordRecord) it.next();
		if (tmp.getElement().getName().equals(wordName )){
			result = tmp;
			}
			}
		return result;
	}
	
	public WordRecord getByIndex( int index ) {
		WordRecord result = null;
		Iterator it = iterator();
		int i = 0;
    
		while ( it.hasNext() && i <= index ) {
			WordRecord tmp = (WordRecord) it.next();
			if ( i == index ) {
				result = tmp;
			}
			i++;
		}
		return result;
	}
	
	public String getType( String wordName ) {
		Iterator it = data.iterator();
		String result = null;
		while(it.hasNext())
		{WordRecord tmp =(WordRecord) it.next();
		if (tmp.getElement().getName().toLowerCase().equals(wordName.toLowerCase() ))
		 result = tmp.getG_cat();
		}
		if ( result == null ) {result="unknown";
			//fatalError( "Requested word unknown ('" + wordName + "')" );
		debug("The word "+wordName+" is not in the dictionary");
		}
		return result; 
	}
	public static void main(String[] args)
	{ArrayList go= new ArrayList();
	//go=getTranslation("between","dic-en-test.xml","dic-de-test.xml");
	//System.out.println(go.get(0));	
	
	Dictionary m=new Dictionary("dict-en.xml");
//	NewWordRecord w=m.getByEntry("between");
	System.out.println("done");}
}
