package mactrans.database;

/**
 * 
 * @author Iuliana Zibilianu (iuliacaz@yahoo.com)
 * @author Jan Kienecker (3kieneck@informatik.uni-hamburg.de)
 * @version $Revision: 1.1.1.1 $
 * 
 * <pre>
 * $Log: SentenceRecord.java,v $
 * Revision 1.1.1.1  2004/12/14 23:28:03  mactrans
 * added to repository
 *
 * </pre>
 */
public class SentenceRecord extends AbstractRecord {
	/* local vars */
	private String language;
	private String equiv;
	private String content;
	
	/**
	 * Creates an empty SentenceRecord
	 *
	 */
	public SentenceRecord() {
		super();
		language = new String();
		equiv = new String();
		content = new String();
	}

	/**
	 * Creates a fully specified SentenceRecord
	 * 
	 * @param id unique key/id
	 * @param language either DE or EN
	 * @param equiv a reference id to the corresponding entry (opposite limba)
	 * @param content the actual sentence
	 */
	public SentenceRecord( String id, String language, String equiv, String content ) {
		super( id );
		this.language = new String( language );
		this.equiv = new String( equiv );
		this.content = new String( content );
	}
	
	/**
	 * @return Returns the sentence from the database.
	 */
	public String getContent() {
		return content;
	}

	/**
	 * @param content The content to set.
	 */
	public void setContent(String content) {
		this.content = content;
	}

	/**
	 * @return Returns an ID to the corresponding sentence in the
	 * opposite language's sentence database 
	 */
	public String getEquiv() {
		return equiv;
	}

	/**
	 * @param equiv The equiv to set.
	 */
	public void setEquiv(String equiv) {
		this.equiv = equiv;
	}

	/**
	 * @return Returns the language, may be DE or EN,
	 * or "ENG" and "DEU"... TODO Normalize the database! 
	 */
	public String getLanguage() {
		return language;
	}

	/**
	 * @param language The language to set.
	 */
	public void setLanguage(String language) {
		this.language = language;
	}
}
